'use strict';
const Emitter = require('jellyemitter');
const JellyPromise = require('jellypromise/production');
const JellyStream = JellyPromise.Stream;
const WiseRiver = require('.');
const WisePromise = WiseRiver.Promise;
const data = new Array(4).fill().map((_, i) => i % 2 ? { foo: 'bar' } : { foo: 'baz' });
const emptyData = [];

const soonWise = (value) => new WisePromise((r) => setImmediate(r, value));
const soonJelly = (value) => new JellyPromise((r) => setImmediate(r, value));

(new (require('benchmark')).Suite)
.add('WiseRiver', { defer: true, fn: (deferred) => {
	WiseRiver.from(data)
		// .map(x => x.foo === 'bar' ? soonWise(x) : x)
		.consume(x => x.foo === 'baz' ? soonWise(x) : x)
		.then(() => deferred.resolve());
}})
.add('jellypromise.Stream', { defer: true, fn: (deferred) => {
	JellyStream.from(data)
		// .map(x => x.foo === 'bar' ? soonJelly(x) : x)
		.forEach(x => x.foo === 'baz' ? soonJelly(x) : x)
		.drain()
		.then(() => deferred.resolve());
	// const count = 4;
	// const sources = new Array(count).fill().map(() => new Emitter);
	// const forks = sources.map(s => new JellyStream(s));
	// const origin = JellyStream.from(data);
	// origin.drain((item) => {
	// 	for (let i = 0; i < count; ++i) sources[i].emit('data', item);
	// });
	// origin.then(() => {
	// 	for (let i = 0; i < count; ++i) sources[i].emit('end');
	// }, (reason) => {
	// 	for (let i = 0; i < count; ++i) sources[i].emit('error', reason);
	// });
	// const comboSource = new Emitter;
	// const comboStream = new JellyStream(comboSource);
	// const writeToComboSource = item => comboSource.emit('data', item);
	// for (const fork of forks) fork.drain(writeToComboSource);
	// JellyPromise.all(forks).then(() => comboSource.emit('end'), reason => comboSource.emit('error', reason));
	// comboStream.drain();
	// comboStream.then(() => deferred.resolve());
}})
.on('cycle', (event) => {
	console.log(String(event.target));
})
.run({ async: true });
