'use strict';
const { Cancellation, NoDataError } = require('.');


const descriptor = { writable: true, enumerable: false, configurable: true, value: 'SimpleError' };
function SimpleError(message) {
	if (new.target !== SimpleError) return new SimpleError(message);
	this.message = '' + message;
	this.stack = `${this.name}: ${this.message}`;
}
Object.setPrototypeOf(SimpleError.prototype, Error.prototype);
Object.defineProperty(SimpleError.prototype, 'name', descriptor);


(new (require('benchmark')).Suite)
.add('Stacktrace', { defer: false, fn: () => {
	new NoDataError('foobar');
}})
.add('No Stacktrace', { defer: false, fn: () => {
	new Cancellation('foobar');
}})
.add('SimpleError', { defer: false, fn: () => {
	new SimpleError('foobar');
}})
.on('cycle', (event) => {
	console.log(String(event.target));
})
.run({ async: true });
